# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para divxatope
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "divxatope"
__category__ = "F,S,D"
__type__ = "generic"
__title__ = "Mejor Torrent"
__language__ = "ES"

DEBUG = config.get_setting("debug")
LOGIN = "popeye20"
PASSWORD = "popeye20"

def isGeneric():
    return True

def mainlist(item):
    logger.info("pelisalacarta.channels.divxatope mainlist")
    itemlist=[]

    item.url="http://www.divxatope.com"
    data = scrapertools.cache_page(item.url)
    logger.info("data="+data)

    menubar = scrapertools.get_match(data,'<nav id="myjquerymenu"[^>]+>[^<]+<ul>(.*?)juegos')

    patron = "<li><a.*?href='([^']+)'[^>]+>([^<]+)</a></li>"
    matches = re.compile(patron,re.DOTALL).findall(menubar)

    for scrapedurl,scrapedtitle in matches:
        title = scrapedtitle
        url = scrapedurl
        itemlist.append( Item(channel=__channel__, action="lista", title=title , url=url , fanart="http://pelisalacarta.mimediacenter.info/fanart/divxatope.jpg", folder=True) )

    if len(itemlist)>0:
        itemlist.append( Item(channel=__channel__ , action="search"    , title="Buscar"))

    return itemlist

def search(item,texto):
    logger.info("pelisalacarta.channels.divxatope search")
    #texto = texto.replace(" ","+")
    post = "categoria=&subcategoria=&idioma=&calidad=&ordenar=Fecha&ord=Descendente&search=%s"
    item.url = "http://www.divxatope.com/buscar/descargas?"+post % (texto)
    return lista(item)
    '''
    try:
        return lista(item)
    # Se captura la excepcin, para no interrumpir al buscador global si un canal falla
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []
    '''

def lista(item):
    logger.info("pelisalacarta.channels.divxatope lista")
    itemlist = []

    ## Descarga la pgina
    #if item.title == "Buscar" or item.title == ">> Pgina siguiente":
    if "search" in item.url:
        # Es una bsqueda
        # La url y los datos se guardaron en item.url
        data = scrapertools.cache_page(item.url.split("?")[0],post=item.url.split("?")[1])
    else:
        data = scrapertools.cachePage(item.url)

    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)
    movielist = scrapertools.get_match(data,'<ul class="peliculas-box"[^>]+>(.*?)</ul>')

    #<li style="width:136px;height:263px;margin:0px 15px 0px 0px;"><a href="http://www.divxatope.com/descargar/asi-nos-va--en-bluray-screeener" title="Descargar Asi Nos Vaen BluRay-Screeener torrent gratis"><divclass='ribbon-estreno' ></div><img class="torrent-image" src="http://www.divxatope.com/uploads/images/fichas/f/thumbs/374779_asi-nos-va--bluray-screeener.jpg" alt="Descargar Asi Nos Vaen BluRay-Screeener torrent gratis" style="width:130px;height:184px;" /><h2 style="float:left;width:100%;margin:3px 0px 0px 0px;padding:0px 0px 3px 0px;line-height:12px;font-size:12px;height:23px;border-bottom:solid 1px #C2D6DB;">Asi Nos Va </h2><strong style="float:left;width:100%;text-align:center;color:#000;margin:0px;padding:3px 0px 0px 0px;font-size:11px;line-height:12px;">BluRay-Screeener<br>Espaol</strong></a></li>

    patron = 'href="([^"]+)".*?'           #scrapedurl
    patron+= 'src="([^"]+)".*?'            #scrapedthumbnail
    patron+= '<h2[^>]+>([^<]+)</h2>'       #scrapedtitle
    patron+= '<strong[^>]+>(.*?)</strong>' #calidad

    matches = re.compile(patron,re.DOTALL).findall(movielist)
    scrapertools.printMatches(matches)

    for scrapedurl, scrapedthumbnail, scrapedtitle, calidad in matches:
        title = scrapedtitle.strip()+" ("+calidad.replace("<br>"," ")+")"
        url = scrapedurl
        thumbnail = scrapedthumbnail
        plot = ""
        if (DEBUG): logger.info("title=["+title+"], url=["+url+"], thumbnail=["+thumbnail+"]")
        itemlist.append( Item(channel=__channel__, action="findvideos", title=title , fulltitle = title, url=url , thumbnail=thumbnail , plot=plot , viewmode="movie", folder=True) )

    # Extrae el paginador
    try:
        if "search" in item.url:
            # Paginador del buscador
            nextpage = scrapertools.get_match(data,'value="Siguiente" onClick="paginar.\'(\d+)\'')
            lastpage = scrapertools.get_match(data,'value="Ultimo" onClick="paginar.\'(\d+)\'')
            if "&pg=" in item.url: item.url = re.sub("pg=\d+","pg="+nextpage,item.url)
            else: item.url = item.url+"&pg="+nextpage
            urlnextpage = item.url
        else:
            # Paginador normal
            nextpage = scrapertools.get_match(data,'<a href=".*?(\d+)">Next</a>')
            lastpage = scrapertools.get_match(data,'<a href=".*?(\d+)" >last</a>')
            urlnextpage = scrapertools.get_match(data,'<a href="([^"]+)">Next</a>')

        title = ">> Ir a pag. "+nextpage+" de "+lastpage
        itemlist.append( Item(channel=__channel__, action="lista", title=title, url=urlnextpage , folder=True) )
    except: pass

    return itemlist

def findvideos(item):
    logger.info("pelisalacarta.channels.divxatope findvideos")
    itemlist=[]

    # Averigua el PHPSESSID
    login = LOGIN.replace("@","%40")
    headers = scrapertools.get_headers_from_response("http://www.divxatope.com/index.php",post="login=%s&password=%s&Submit=ENTRAR" % (login,PASSWORD))
    logger.info("headers="+str(headers))
    request_headers=[ ["User-Agent","Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:14.0) Gecko/20100101 Firefox/14.0.1"] ]
    for header in headers:
        if header[0]=="set-cookie":
            #['set-cookie', 'PHPSESSID=d514b41a42fec11a7cae8bdb07fcef58; path=/']
            #Cookie: PHPSESSID=82336dad3c64c9c4110e793aa54abc4a;
            cookie_value = scrapertools.get_match(header[1],"PHPSESSID\=([a-z0-9]+)\;")
            request_headers.append(["Cookie","PHPSESSID="+cookie_value])

    ## Cualquiera de las tres opciones son vlidas
    #item.url = item.url.replace("descargar","ver-online")
    #item.url = item.url.replace("descargar","descarga-directa")
    item.url = item.url.replace("descargar","descarga-torrent")

    # Descarga la pgina
    data = scrapertools.cache_page(item.url,headers=request_headers)

    #<a href="http://tumejorserie.com/redirect/download.php?url=http://www.divxatope.com/torrent/374608_lucy-web-screener-r3-espa%C3%B1ol-castellano-2014.html" target="_blank" class="btn-torrent">Descarga tu Archivo torrent!</a>

    link = scrapertools.find_single_match(data,'href="http://tumejorserie.*?url=([^"]+)"')
    if link!="":
        #link = "http://www.divxatope.com/"+link
        logger.info("pelisalacarta.channels.divxatope torrent="+link)
        itemlist.append( Item(channel=__channel__, action="play", server="torrent", title=item.title , fulltitle = item.title, url=link , thumbnail=item.thumbnail , plot=item.plot , folder=False) )

    ## Ahora busca los vdeos
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)
    data = re.sub(r"width=.33. height=.33.| rel=.nofollow. target=._blank.","",data)
    data = re.sub(r"<div class=.box6.>.*?<div class=.ribbon.estreno.></div>","",data)
    data = re.sub(r"'",'"',data)

    itemlist.extend(servertools.find_video_items(data=data))

    for videoitem in itemlist:
        videoitem.channel = __channel__
        fichero = scrapertools.get_filename_from_url(videoitem.url)
        partes = fichero.split("/")
        titulo = partes[ len(partes)-1 ]
        videoitem.title = titulo + " - [" + videoitem.server+"]"
        videoitem.fulltitle = item.fulltitle

    return itemlist

# Verificacin automtica de canales: Esta funcin debe devolver "True" si todo est ok en el canal.
def test():
    bien = True
    
    # mainlist
    mainlist_items = mainlist(Item())
    
    # Da por bueno el canal si alguno de los vdeos de "Novedades" devuelve mirrors
    for mainlist_item in mainlist_items:
        if "DVDRip Castellano" in mainlist_item.title:
            peliculas_items = lista(mainlist_item)
            break
    
    bien = False
    for pelicula_item in peliculas_items:
        mirrors = findvideos(pelicula_item)
        if len(mirrors)>0:
            bien = True
            break

    return bien
